applications/biblioteca/urls.py
from django.urls import path, re_path

from . import views

app_name="biblioteca_app"

urlpatterns = [
    path('', views.ListaAutores.as_view(), name="lista-autores"),
    path('libros-autor/<pk>/por-autor', views.ListaLibrosAutores.as_view(), name="lista-libros"),
    path('autor/add', views.AddAutor.as_view(), name="autor-add"),
]

applications/home/urls.py
from django.urls import path, re_path

from . import views

app_name="home_app"

urlpatterns = [
    path('index', views.IndexView.as_view(), name="index"),
    path('libros', views.ListaLibros.as_view(), name="lista"),
]

libro/urls.py
"""
archivo principal de url
"""
from django.contrib import admin
from django.urls import path, re_path, include

urlpatterns = [
    # #urls para aplicacion home
    re_path(r'^', include('applications.home.urls')),
    re_path(r'^', include('applications.biblioteca.urls')),
    re_path('admin/', admin.site.urls),
]

applications/biblioteca/models.py
from django.db import models

# Create your models here.
class Autor(models.Model):
    nombre = models.CharField('Nombres', max_length=80)
    nacionalidad = models.CharField(blank=True, max_length=100)

    def __str__(self):
        return self.nombre


class Libros(models.Model):
    title = models.CharField('titulo', blank=False, max_length=150)
    resume = models.TextField('Resumen', blank=True)
    autor = models.ForeignKey(Autor, on_delete=models.CASCADE)

    def __str__(self):
        return self.title

applications/home/models.py
from django.db import models

# Create your models here.

applications/biblioteca/views.py
from django.shortcuts import render
#django library
from django.views.generic import (
    TemplateView,
    ListView,
    CreateView,
)

from .models import Autor, Libros


class ListaAutores(ListView):
    template_name = 'biblioteca/lista-autores.html'
    model = Autor
    context_object_name = 'autores'


class ListaLibrosAutores(ListView):
    """ vista para listar libros por autor """
    template_name = 'biblioteca/lista-libros.html'
    context_object_name = 'libros'

    def get_queryset(self):
        # identificar el autor
        id = self.kwargs['pk']
        # filtro de los libros
        lista = Libros.objects.filter(
            autor=id
        )
        # devuelvo el resultado o la lista resultado
        return lista


class AddAutor(CreateView):
    """ vista para registrar un nuevo autor """
    template_name = 'biblioteca/add-autor.html'
    model = Autor
    fields = ['nombre', 'nacionalidad']
    success_url = '/'

applications/home/views.py
from django.shortcuts import render
#django library
from django.views.generic import (
    TemplateView,
    ListView,
)

class IndexView(TemplateView):
    # que una vista procesa los datos y renderiza el rsultado en pantalla
    # siempre nos pedira un template con el que trabajar
    # un template es un archivo html
    template_name = "home/index.html"


class ListaLibros(ListView):
    template_name = 'home/lista.html'
    queryset = ['El quijote de la mancha', 'Codigo Limpio', 'La sombra del viento', 'Django 2.0']
    context_object_name = 'libros'

templates/biblioteca/add-autor.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>Agregar Autor</title>
  </head>
  <body>
    <h1>Agregar Autor</h1>
    <form method="post">{% csrf_token %}
      {{form.as_p}}
      <button type="submit" name="button">Guardar</button>
    </form>
  </body>
</html>

templates/biblioteca/lista-autores.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>Lista de autores</title>
  </head>
  <body>
    <h1>Autores Registrados</h1>
    <table border="1">
      <thead>
        <th>ID</th>
        <th>Nombres</th>
        <th>Nacionalidad</th>
        <th>Accion</th>
      </thead>
      <tbody>
        {% for a in autores  %}
          <tr>
            <td>{{a.id}}</td>
            <td>{{a.nombre}}</td>
            <td>{{a.nacionalidad}}</td>
            <td><a href="{% url 'biblioteca_app:lista-libros' a.id %}">VER LIBROS</a></td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </body>
</html>

templates/biblioteca/lista-libros.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title>Lista libros por autor</title>
  </head>
  <body>
    <h1>Lista libros autor</h1>
    <table border="1">
      <thead>
        <th>ID</th>
        <th>Titulo</th>
        <th>Autor</th>
      </thead>
      <tbody>
        {% for l in libros  %}
          <tr>
            <td>{{l.id}}</td>
            <td>{{l.title}}</td>
            <td>{{l.autor.nombre}}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </body>
</html>

templates/home/index.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title></title>
  </head>
  <body>
    <h1>mi primera vista en django</h1>
  </body>
</html>

templates/home/lista.html
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title></title>
  </head>
  <body>
    <h1>Lista de libros - probando vistas genericas</h1>
    {% for l in libros  %}
      <p>{{ l }}</p>
    {% endfor %}
  </body>
</html>